; MEMTEST.ASM, typed by Denver Hull Nov 2006
;	from the book
;	"The S100 Bus Handbook"
;		- some mods
;
;	input starting address and size (4 uc char ea) at the "*" prompt


	org	0000h

conc	equ	03h
cond	equ	02h
txrdy	equ	01h
rxrdy	equ	02h

sptr	equ	0100h		; stack

start:	lxi	sp, sptr
	mvi	a, 0aah		; init sio2 port
	out	conc
	mvi	a, 40h
	out	conc
	mvi	a, 0ceh
	out	conc
	mvi	a, 37h
	out	conc
	call	crlf
	mvi	a, '*'		; prompt
	call	ptcn
	jmp	tmem

tmem:	call	ahex		; starting address
	xchg
	call	ahex		; size
	xchg
	lxi	b, 05a5ah
cycl:	call	rndm
	push	b
	push	h
	push	d
tlop:	call	rndm
	mov	m, b		; write the data
	inx	h
	dcx	d
	mov	a, d		; done with this pass?
	ora	e
	jnz	tlop		; no
	pop	d
	pop	h
	pop	b
	push	h
	push	d
rlop:	call	rndm
	mov	a, m		; check the data
	cmp 	b
	cnz	err
	inx	h
	dcx	d
	mov	a, d		; done?
	ora	e
	jnz	rlop		; no
	pop	d
	pop	h
	jmp	cycl

ahex:	lxi	h, 0		; ascii to hex, result in hl
	mvi	c, 4		; 4 characters
ahe1:	call	rdcn		; get one char
	dad	h		; shift left 4
	dad	h
	dad	h
	dad	h
	sui 	48		; convert to hex
	cpi	10
	jc	alf
	sui	7
alf:	add	l
	mov	l, a
	dcr	c		; got all 4?
	jnz	ahe1		; no
spce:	mvi	a, 20h		; yes, output a space
ptcn:	push	psw
ptlop:	in	conc
	ani	txrdy
	jz	ptlop
	pop	psw
	out	cond
	ret

crlf:	mvi	a, 0dh		; output a cr/lf
	call	ptcn
	mvi	a, 0ah
	jmp	ptcn

rdcn:	in	conc		; get a character from the console
	ani	rxrdy
	jz	rdcn
	in	cond
	ani	7fh
	jmp	ptcn

rndm:	mov	a, b		; make a random number
	ani	0b4h
	ana	a
	jpe	peve
	stc
peve:	mov	a, c
	ral
	mov	c, a
	mov	 a, b
	ral
	mov	b, a
	ret			; random # in bc

ptad:	call	crlf		; print error
	mov	a, h
	call 	pt2
	mov	a, l
	call	 pt2
	call	spce
	call	spce
	ret

err:	push	psw
	call	ptad
	mov	a, b
	call	pt2
	call	spce
	call	spce
	pop	psw
pt2:	push	psw
	call	binh
	pop	psw
	jmp	binl
binh:	rar
	rar
	rar
	rar
binl:	ani	0fh
	adi	48
	cpi	58
	jc	ptcn
	adi	7
	jmp	ptcn


